package org.artifactory.ph;

import com.jfrog.ph.acl.service.PackageAnalyticsService;
import org.artifactory.addon.AddonsManager;
import org.artifactory.addon.analytics.AnalyticsAddon;
import org.artifactory.common.repo.PackageType;
import org.artifactory.descriptor.repo.RepoType;

public class PackageAnalyticsServiceImpl implements PackageAnalyticsService {

    private final AddonsManager addonsManager;

    public PackageAnalyticsServiceImpl(AddonsManager addonsManager) {
        this.addonsManager = addonsManager;
    }

    @Override
    public void onSuccessfulPackageDownload(PackageType packageType, String repoKey, String packageName,
            String version) {
        addonsManager.addonByType(AnalyticsAddon.class)
                .onSuccessfulPackageDownload(RepoType.fromType(packageType.name()), repoKey, packageName, version);
    }

    @Override
    public void onSuccessfulPackageUpload(PackageType packageType, String repoKey, String packageName, String version) {
        addonsManager.addonByType(AnalyticsAddon.class)
                .onSuccessfulPackageUpload(RepoType.fromType(packageType.name()), repoKey, packageName, version);
    }

    @Override
    public void userCreatedToken(PackageType packageType, String userName) {
        addonsManager.addonByType(AnalyticsAddon.class)
                .userCreatedToken(RepoType.fromType(packageType.name()), userName);
    }
}
