package org.artifactory.ph;

import org.artifactory.addon.oauth.OAuthHandler;
import org.artifactory.addon.oauth.SsoLoginModel;
import com.jfrog.ph.acl.model.sso.PackageSsoLoginModel;
import com.jfrog.ph.acl.service.PackageOAuthHandler;

import javax.servlet.http.HttpServletRequest;
import javax.ws.rs.core.Response;
import java.util.Optional;

/**
 * PackageOAuthHandler expose {@link OAuthHandler} abilities to the Package handler module.
 */
public class PackageOAuthHandlerImpl implements PackageOAuthHandler {

    private final OAuthHandler oAuthHandler;

    public PackageOAuthHandlerImpl(OAuthHandler oAuthHandler) {
        this.oAuthHandler = oAuthHandler;
    }

    @Override
    public Response handleLogin(String method, String name, String path, HttpServletRequest request,
            PackageSsoLoginModel packageSsoLoginModel) {
        SsoLoginModel loginModel = new SsoLoginModel();
        loginModel.setName(packageSsoLoginModel.getName());
        loginModel.setPassword(packageSsoLoginModel.getPassword());
        return (Response) oAuthHandler.handleLogin(method, name, path, request, loginModel);
    }

    @Override
    public Optional<String> getNpmLoginHandler() {
        return oAuthHandler.getNpmLoginHandler();
    }
}
