package org.artifactory.logging.filters;

import ch.qos.logback.core.filter.AbstractMatcherFilter;
import ch.qos.logback.core.spi.FilterReply;
import org.artifactory.common.home.ArtifactoryHome;

/**
 * @author Tomer Slutsky
 */
public class ConsoleJsonFormatFilter extends AbstractMatcherFilter {
    static final String ENABLE_CONSOLE_LOG_PRO_NAME = "shared.logging.enableJsonConsoleLogAppenders";

    @Override
    public FilterReply decide(Object event) {
        if (shouldPrintLog()) {
            return FilterReply.ACCEPT;
        }
        return FilterReply.DENY;
    }

    private boolean shouldPrintLog() {
        return ArtifactoryHome.isBound() &&
                ArtifactoryHome.get().getSysConfig().getBoolean(ENABLE_CONSOLE_LOG_PRO_NAME, false);
    }
}
