package org.artifactory.logging.layout;

import ch.qos.logback.classic.spi.ILoggingEvent;
import ch.qos.logback.contrib.json.classic.JsonLayout;
import ch.qos.logback.core.CoreConstants;
import lombok.extern.slf4j.Slf4j;
import org.jfrog.common.JsonUtils;

import java.util.Map;

/**
 * @author Tomer Slutsky
 */
@Slf4j
public class BaseJsonLayout extends JsonLayout {

    public BaseJsonLayout() {
        this.appendLineSeparator = true;
    }

    @Override
    public String doLayout(ILoggingEvent event) {
        Map<String, Object> data = toJsonMap(event);
        log.trace("Converting log data to string");
        String finalLog = JsonUtils.getInstance().valueToString(data);
        log.trace("Finished log data to string");
        return this.isAppendLineSeparator() ? finalLog + CoreConstants.LINE_SEPARATOR : finalLog;
    }
}
