package org.artifactory.logging.layout.request;

import ch.qos.logback.classic.spi.ILoggingEvent;
import lombok.extern.slf4j.Slf4j;
import org.artifactory.logging.layout.BaseJsonLayout;
import org.artifactory.logging.layout.SaasLogParts;

import java.util.Map;

import static org.artifactory.logging.SaasLogNames.OUTBOUND_REQUEST_LOG;

/**
 * @author Tomer Slutsky
 */
@Slf4j
public class OutboundRequestJsonLayout extends BaseJsonLayout {
    public OutboundRequestJsonLayout() {
        super();
    }

    @Override
    protected void addCustomDataToJsonMap(Map<String, Object> data, ILoggingEvent event) {
        log.trace("Clearing original data in artifactory request out log json layout");
        data.clear();
        data.put(OUTBOUND_REQUEST_LOG.getLogKey(), OUTBOUND_REQUEST_LOG.getLogName());
        log.trace("Adding request to artifactory request out log with json layout");
        data.put("request", SaasLogParts.getOutboundRequestEntryPart(event));
        log.trace("Adding response to artifactory request log with json layout");
        data.put("response", SaasLogParts.getResponseEntryPart(event));
    }
}
