package org.artifactory.logging.layout.access;

import io.vavr.collection.Array;
import org.artifactory.logging.LoggingTestUtils;
import org.artifactory.logging.SaasLogNames;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

/**
 * @author Tomer Slutsky
 */
public class AccessJsonLayoutTest {
    AccessJsonLayout accessJsonLayout = new AccessJsonLayout();

    @Test
    public void testDoLayout() {
        String s = accessJsonLayout.doLayout(LoggingTestUtils
                .createEvent(Array.of("ACCEPTED", "LOGIN", "", "", "jffe@000", "127.0.0.71"),
                        AccessJsonLayoutTest.class));
        Assertions.assertTrue(s.contains("\"" + SaasLogNames.ACCESS_LOG.getLogKey() + "\":\"" +
                SaasLogNames.ACCESS_LOG.getLogName() + "\""));
        Assertions.assertTrue(s.contains("\"traceid\":\"traceid\""));
        Assertions.assertTrue(s.contains("\"actionresponse\":\"ACCEPTED LOGIN\""));
        Assertions.assertTrue(s.contains("\"username\":\"jffe@000\""));
        Assertions.assertTrue(s.contains("\"userip\":\"127.0.0.71\""));
        Assertions.assertTrue(s.contains("\"repositorypath\":"));
        Assertions.assertTrue(s.contains("\"message\":"));
        Assertions.assertTrue(s.contains("\"access\":{"));
    }
}