package org.artifactory.repo;

import org.artifactory.descriptor.repo.RepoType;
import org.artifactory.model.RemoteRepoConfig;
import org.testng.annotations.Test;

import static org.artifactory.repo.config.RepoConfigDefaultValues.DEFAULT_METADATA_RETRIEVAL_TIMEOUT_SECS;
import static org.testng.Assert.assertEquals;

/**
 * @author Alexei Vainshtein
 */
public class HttpRepositoryConfigurationImplTest {

    @Test
    public void testSetMetadataRetrievalTimeoutSecs() {
        HttpRepositoryConfigurationImpl httpRepoDescriptor = new HttpRepositoryConfigurationImpl();
        httpRepoDescriptor.setMetadataRetrievalTimeoutSecs(20);
        assertEquals(httpRepoDescriptor.getMetadataRetrievalTimeoutSecs(), 20);
    }

    @Test
    public void testDefaultValues() {
        HttpRepositoryConfigurationImpl httpRepoDescriptor = new HttpRepositoryConfigurationImpl();
        assertEquals(httpRepoDescriptor.getMetadataRetrievalTimeoutSecs(), DEFAULT_METADATA_RETRIEVAL_TIMEOUT_SECS);

        RemoteRepoConfig remoteRepoConfig = RemoteRepoConfig.create("repoKey", RepoType.Generic);
        remoteRepoConfig.getRepoTypeConfig().setUrl("http://localhost");
        remoteRepoConfig.getRepoTypeConfig().setMetadataRetrievalTimeoutSecs(20);

        httpRepoDescriptor = new HttpRepositoryConfigurationImpl(remoteRepoConfig);
        assertEquals(httpRepoDescriptor.getMetadataRetrievalTimeoutSecs(),
                remoteRepoConfig.getRepoTypeConfig().getMetadataRetrievalTimeoutSecs());
    }
}