package org.artifactory.storage.binstore.service;

import org.artifactory.storage.binstore.service.cleanup.GarbageCollectorStrategy;
import org.artifactory.test.ArtifactoryHomeBoundTest;
import org.jfrog.storage.binstore.ifc.GarbageCollectListenerResultStatus;
import org.jfrog.storage.binstore.ifc.GarbageCollectorInfo;
import org.testng.Assert;
import org.testng.annotations.Test;

/**
 * @author Alexei Vainshtein
 */
public class GarbageCollectorInfoTest extends ArtifactoryHomeBoundTest {

    @Test
    public void setStatusTest() {
        GarbageCollectorInfo garbageCollectorInfo =
                new GarbageCollectorInfo(GarbageCollectorStrategy.FULL.name(), 10);
        Assert.assertEquals(garbageCollectorInfo.getStatus(), GarbageCollectListenerResultStatus.UNCOMPLETED);
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.getStrategy(), GarbageCollectorStrategy.FULL.name());
        Assert.assertEquals(garbageCollectorInfo.getFailures(), 0);
        Assert.assertEquals(garbageCollectorInfo.getStatus(), GarbageCollectListenerResultStatus.COMPLETED);
        garbageCollectorInfo.setStatus(GarbageCollectListenerResultStatus.UNCOMPLETED);

        garbageCollectorInfo.setCandidatesForDeletion(5);
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.getStrategy(), GarbageCollectorStrategy.FULL.name());
        Assert.assertEquals(garbageCollectorInfo.getStatus(), GarbageCollectListenerResultStatus.COMPLETED);
        garbageCollectorInfo.setStatus(GarbageCollectListenerResultStatus.UNCOMPLETED);

        garbageCollectorInfo.setFailures(5);
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.getStrategy(), GarbageCollectorStrategy.FULL.name());
        Assert.assertEquals(garbageCollectorInfo.getStatus(), GarbageCollectListenerResultStatus.UNCOMPLETED);

        garbageCollectorInfo.setFailures(6);
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.getStrategy(), GarbageCollectorStrategy.FULL.name());
        Assert.assertEquals(garbageCollectorInfo.getStatus(), GarbageCollectListenerResultStatus.UNCOMPLETED);

        garbageCollectorInfo.setCandidatesForDeletion(25);
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.getStrategy(), GarbageCollectorStrategy.FULL.name());
        Assert.assertEquals(garbageCollectorInfo.getFailures(), 6);
        Assert.assertEquals(garbageCollectorInfo.getStatus(), GarbageCollectListenerResultStatus.COMPLETED);
        garbageCollectorInfo.setStatus(GarbageCollectListenerResultStatus.UNCOMPLETED);

        garbageCollectorInfo.setFailures(10);
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.getStrategy(), GarbageCollectorStrategy.FULL.name());
        Assert.assertEquals(garbageCollectorInfo.getStatus(), GarbageCollectListenerResultStatus.UNCOMPLETED);

        garbageCollectorInfo.setFailures(11);
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.getStrategy(), GarbageCollectorStrategy.FULL.name());
        Assert.assertEquals(garbageCollectorInfo.getStatus(), GarbageCollectListenerResultStatus.UNCOMPLETED);
    }
}
