package org.artifactory.storage.db.repo.service.mapper;

import org.artifactory.descriptor.repo.RepoType;
import org.artifactory.repo.RepoDetailsType;
import org.mapstruct.Mapper;
import org.mapstruct.Named;

import java.util.Locale;

/**
 * @author Tamar Rosen
 */
@Mapper
@Named("RepositoryConfigAttributesMapper")
public interface RepositoryConfigAttributesMapper {
    @Named("repoDetailTypeToLowercaseRepoTypeName")
    default String repoDetailTypeToLowercaseRepoTypeName(RepoDetailsType repoDetailsType) {
        return repoDetailsType.typeNameLowercase();
    }

    @Named("packageTypeToTypeString")
    default String packageTypeToTypeString(RepoType packageType) {
        return packageType.getType();
    }

    @Named("typeStringToPackageType")
    default RepoType typeStringToPackageType(String packageType) {
        return RepoType.fromType(packageType);
    }

    @Named("repoDetailTypeStringToRepoDetailType")
    default RepoDetailsType repoTypeNameToRepoDetailsType(String repoDetailsType) {
        return RepoDetailsType.byNativeName(repoDetailsType.toLowerCase(Locale.ROOT));
    }
}
