package org.artifactory.storage.db.upgrades.itest.version;


import org.artifactory.storage.db.upgrades.common.UpgradeBaseTest;
import org.artifactory.storage.db.version.ArtifactoryDBVersion;
import org.jfrog.converter.model.ChangeLogContext;
import org.jfrog.storage.util.DbUtils;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

import java.io.IOException;
import java.sql.SQLException;

import static org.artifactory.storage.db.version.ArtifactoryDBVersion.v145;
import static org.artifactory.storage.db.version.ArtifactoryDBVersion.v146;
import static org.testng.Assert.assertTrue;

public class V145ToV146AddIndexToLocalRepoKeyColumnBinariesTaskTableTest extends UpgradeBaseTest {
    @BeforeMethod
    public void setup() throws IOException, SQLException {
        resetToVersion(v145);
    }

    @Test
    public void testRepoKeyIndexExists() throws SQLException {
        try (ChangeLogContext context = new ChangeLogContext(jdbcHelper.getDataSource().getConnection(),
                dbProperties.getDbType(), v146)) {
            v146.converter().convert(context);
        }
        assertTrue(indexExist());
    }

    private Boolean indexExist() throws java.sql.SQLException {
        return DbUtils.withConnection(jdbcHelper,
                conn -> DbUtils
                        .indexExists(conn, dbProperties.getDbType(), "binaries_tasks", "local_repo_key",
                                "binaries_tasks_repo_key_idx", false));
    }

    @Override
    protected ArtifactoryDBVersion upToVersion() {
        return v146;
    }
}
