package org.artifactory.rest.resource.release;

import com.jfrog.retention.acl.bridge.TargetBundleRetentionBridgeToModule;
import lombok.NonNull;
import org.artifactory.api.rest.constant.HaRestConstants;
import org.artifactory.api.rest.constant.SystemRestConstants;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import javax.annotation.security.RolesAllowed;
import javax.inject.Inject;
import javax.ws.rs.Consumes;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

@Path(SystemRestConstants.JFROG_RELEASE)
@Component
@Scope(BeanDefinition.SCOPE_PROTOTYPE)
public class TargetBundleRetentionResource {

    private final TargetBundleRetentionBridgeToModule bridgeToModule;

    @Inject
    TargetBundleRetentionResource(@NonNull TargetBundleRetentionBridgeToModule bridgeToModule) {
        this.bridgeToModule = bridgeToModule;
    }

    @Path("/target/retention/propagate")
    @RolesAllowed({HaRestConstants.ROLE_HA})
    @Consumes(MediaType.TEXT_PLAIN)
    @Produces(MediaType.TEXT_PLAIN)
    @POST
    @NonNull
    public Response propagateOperation(@NonNull String operationModel) {
        String result = bridgeToModule.onPropagated(operationModel);
        return Response.ok().entity(result).build();
    }
}


